From 9ab7fe302ba7de40593e7cba8ea1ca3b876c1ea5 Mon Sep 17 00:00:00 2001
From: Boris Mironov <boris.mironov@gmail.com>
Date: Thu, 29 Jan 2026 19:22:16 +0700
Subject: [PATCH v9 13/26] Moving PQclear call to the end of procedure to avoid
 access to previously released memory

---
 src/bin/pgbench/pgbench.c | 27 +++++++++++++++++----------
 1 file changed, 17 insertions(+), 10 deletions(-)

diff --git a/src/bin/pgbench/pgbench.c b/src/bin/pgbench/pgbench.c
index 682db61ff61..3687b65871e 100644
--- a/src/bin/pgbench/pgbench.c
+++ b/src/bin/pgbench/pgbench.c
@@ -5363,11 +5363,11 @@ static void
 initBranchBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
 {
 	/*
-	 * Each row has following extra bytes:
+	 * Each row of branch table has following extra bytes:
 	 * - 2 bytes for number of columns
-	 * - 4 bytes as length for each column
+	 * - 4 bytes as length for each of table's 3 columns
 	 */
-	int16_t	max_row_len =  35 + 2 + 4*3; /* max row size is 32 */
+	int16_t	max_row_len =  35 + 2 + 4*3; /* max row size is 35 */
 
 	flushBuffer(con, res, max_row_len);
 
@@ -5384,9 +5384,9 @@ static void
 initTellerBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
 {
 	/*
-	 * Each row has following extra bytes:
+	 * Each row of tellers table has following extra bytes:
 	 * - 2 bytes for number of columns
-	 * - 4 bytes as length for each column
+	 * - 4 bytes as length for each of table's 4 columns
 	 */
 	int16_t	max_row_len =  40 + 2 + 4*4; /* max row size is 40 */
 
@@ -5406,9 +5406,9 @@ static void
 initAccountBinary(PGconn *con, PGresult *res, int64_t curr, int32_t parent)
 {
 	/*
-	 * Each row has following extra bytes:
+	 * Each row of accounts table has following extra bytes:
 	 * - 2 bytes for number of columns
-	 * - 4 bytes as length for each column
+	 * - 4 bytes as length for each of table's 4 columns
 	 */
 	int16_t	max_row_len = 250 + 2 + 4*4; /* max row size is 250 for int64 */
 
@@ -5455,11 +5455,11 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 
 	if (PQresultStatus(res) != PGRES_COPY_IN)
 		pg_fatal("unexpected copy in result: %s", PQerrorMessage(con));
-	PQclear(res);
 
 
 	sendBinaryCopyHeader(con);
 
+
 	for (int64_t i = start; i < start + base; i++)
 	{
 		init_row(con, res, i, base);
@@ -5470,8 +5470,10 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 	else
 		fprintf(stderr, "Unexpected mode %d instead of %d\n", PQresultStatus(res), PGRES_COPY_IN);
 
+
 	sendBinaryCopyTrailer(con);
 
+
 	if (PQresultStatus(res) == PGRES_COPY_IN)
 	{
 		if (PQputCopyEnd(con, NULL) == 1) /* success */
@@ -5484,6 +5486,8 @@ initPopulateTableBinary(PGconn *con, char *table, char *columns,
 		else
 			fprintf(stderr, "Error: %s\n", PQerrorMessage(con));
 	}
+
+	PQclear(res);
 }
 
 /*
@@ -5499,8 +5503,9 @@ initGenerateDataClientSideBinary(PGconn *con)
 	bin_copy_buffer_length = 0;
 
 	/*
-	 * we do all of this in one transaction to enable the backend's
-	 * data-loading optimizations
+	 * we do all of this in multiple transactions
+	 * to minimize load on DB server and perhaps
+	 * in future allow load in parallel sessions
 	 */
 	executeStatement(con, "begin");
 
@@ -5511,6 +5516,8 @@ initGenerateDataClientSideBinary(PGconn *con)
 
 	for (int i = 0; i < scale; i++)
 	{
+		executeStatement(con, "begin");
+
 		initPopulateTableBinary(con, "pgbench_branches", "bid, bbalance",
 								i, nbranches, initBranchBinary);
 		initPopulateTableBinary(con, "pgbench_tellers",  "tid, bid, tbalance",
-- 
2.43.0

